package com.ur.urcap.externalaxis.coordinatedmotionprogrammer.impl;

import java.util.Locale;

import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.program.ContributionConfiguration;
import com.ur.urcap.api.contribution.program.CreationContext;
import com.ur.urcap.api.contribution.program.ProgramAPIProvider;
import com.ur.urcap.api.contribution.program.swing.SwingProgramNodeService;
import com.ur.urcap.api.domain.data.DataModel;

public
class CoordinatedProcessProgramNodeService implements
    SwingProgramNodeService<CoordinatedProcessProgramNodeContribution,
                            CoordinatedProcessProgramNodeView> {
 public
  CoordinatedProcessProgramNodeService() {}

  @Override public String getId() {
    return "CoordinatedProcessNode";
  }

  @Override public String getTitle(Locale locale) {
    return "Coordinated Move";
  }

  @Override public void configureContribution(
      ContributionConfiguration configuration) {
    configuration.setChildrenAllowed(true);
  }

  @Override public CoordinatedProcessProgramNodeView createView(
      ViewAPIProvider apiProvider) {
    return new CoordinatedProcessProgramNodeView(apiProvider, new V5Style());
  }

  @Override public CoordinatedProcessProgramNodeContribution createNode(
      ProgramAPIProvider apiProvider,
      CoordinatedProcessProgramNodeView view,
      DataModel model,
      CreationContext context) {
    return new CoordinatedProcessProgramNodeContribution(apiProvider, view,
                                                         model);
  }
}
