package com.ur.urcap.externalaxis.coordinatedmotionprogrammer.impl;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.ObjectInputStream;
import java.io.StringReader;
import java.net.Socket;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.concurrent.Callable;
import java.util.concurrent.FutureTask;
import java.net.ServerSocket;
import java.net.SocketTimeoutException;

import com.ur.urcap.api.contribution.ProgramNodeContribution;
import com.ur.urcap.api.contribution.program.ProgramAPIProvider;
import com.ur.urcap.api.domain.data.DataModel;
import com.ur.urcap.api.domain.script.ScriptWriter;
import com.ur.urcap.api.domain.undoredo.UndoRedoManager;
import com.ur.urcap.api.domain.undoredo.UndoableChanges;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardInputCallback;
import com.ur.urcap.api.domain.userinteraction.keyboard.KeyboardNumberInput;

public
class MovePWithAxisGroupNodeContribution extends
    BaseMoveWithAxisGroupNodeContribution implements ProgramNodeContribution,
    MovePWithAxisGroupNodeInterface {
 private
  final MovePWithAxisGroupNodeView view;

 private
  final DataModel model;

 private
  final UndoRedoManager undoRedoManager;

 public
  MovePWithAxisGroupNodeContribution(ProgramAPIProvider apiProvider,
                                     MovePWithAxisGroupNodeView view,
                                     DataModel model) {
    super(apiProvider, view, model);

    this.view = view;
    this.model = model;
    this.undoRedoManager = apiProvider.getProgramAPI().getUndoRedoManager();
  }

  @Override public void openView() {
    super.openView();
  }

  @Override public void closeView() {
  }

  @Override public String getTitle() {
    return "MoveP with Axis Group";
  }

  // This is intentionally left empty because the CoordinatedProcessNode is in
  // charge of writing the script when the program is run or saved.
  @Override public void generateScript(ScriptWriter writer) {
  }

  @Override public String getAxisGroup() {
    return super.getAxisGroup();
  }

  @Override public String getAxisWaypoint() {
    return super.getAxisWaypoint();
  }

  @Override public String getRobotWaypoint() {
    return super.getRobotWaypoint();
  }

  @Override public Double getSpeed() {
    return super.getSpeed();
  }

  @Override public Double getAcceleration() {
    return super.getAcceleration();
  }

  @Override public Double getBlendRadius() {
    return super.getBlendRadius();
  }
}
