# Linear Axis Calibration URCap Example
## Description
The linear-axis-calibration URCap provides a working example for calibrating a linear axis by sampling
a sequence of TCP poses.
## Build
* The URCap SDK must be installed and available in the build environment
1.
   ```bash
   cd linear-axis-calibration
   ```
2.
   ```bash
   ./build.sh
   ```
Note: By default the build script will attempt to build the URCap then deploy to a local simulator (if available).
## Usage
1. Configure an external axis using either URScript or the MotionPlus ethercat-axis-config URCap.
2. Go into the Installation tab in Polyscope and click on the Linear Axis Calibration URCap.
3. Choose the configured axis you want to calibrate from the dropdown menu.
4. Choose whether the robot is mounted on the linear axis using the checkbox.
5. To calibrate an axis follow the Calibration Steps laid out in the URCap:
   ![installation node](./docs/images/linear-axis-calibration-installation-node.png)

6. When at least 4 poses have been sampled the 'Calibrate Axis' button will be enabled.
   When the 'Calibrate Axis' button is clicked the URCap will send a URScript with the MotionPlus 'calibrate_linear_axis' command
   using the sampled poses as arguments. The URCap will then wait for the robot to finish the calibration process before displaying the calibration results.

7. To use the calibration click the 'Copy pose to clipboard' and paste to the desired program or URCap. This can be
   achieved using e.g. the keyboard shortcut (Ctrl+V) or simply by typing in the pose in the desired location.
8. To use the calibrated pose please consult the 'Single Linear Axis Calibration' example found in the online documentation for MotionPlus. 
When using the script it is important to update the 'CAL_AX_LINEAR' installation variable with the calibration result before using the example. When using the example simply comment out the 
'my_calibrate_linear_axis()' function call at the end of the script - this will ensure that you do not restart the calibration.


Please note that when sampling the first pose, with the robot mounted on the rail, the current position of the axis is
read and considered to be the origin offset. This offset is later subtracted from the calibrated pose. 
There is no need to manually set and subtract the origin offset. 

To start a new calibration click the 'Clear' button to clear the sampled poses.