package com.ur.urcap.externalaxis.linearaxiscalibration.URCommunicator;

import java.io.*;
import java.net.Socket;

public class DashboardServerCommunicator {
    /**
     * Sends command to dashboard and returns the reply
     *
     * @param command      the command to be send (see the dashboard interface)
     * @param readResponse indicates if a response is expected.
     * @return {@link String} dashboard return message or empty if no response is
     *         expected
     */

    public String sendAndRead(String command, boolean readResponse) throws IOException {
        Socket socket = new Socket("127.0.0.1", 29999);
        socket.setSoTimeout(200);

        BufferedReader in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        BufferedWriter out = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));

        // Readout the buffer

        while (!in.ready())
            try {
                Thread.sleep(10);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        in.readLine();

        out.write(command);
        out.newLine();
        out.flush();

        String ret = "";
        if (readResponse) {
            ret = in.readLine();
        }

        socket.close();
        return ret;
    }

    public String robotmode() throws IOException {
        return sendAndRead("robotmode", true);
    }

    public void popup(String text) throws IOException {
        sendAndRead("popup " + text, false);
    }
}
