package com.ur.urcap.externalaxis.linearaxiscalibration.installationNode.installationNodeView;

import com.ur.urcap.api.contribution.installation.swing.SwingInstallationNodeView;
import com.ur.urcap.externalaxis.linearaxiscalibration.installationNode.installationNodeContribution.LinearAxisCalibrationInstallationNodeContribution;

import javax.swing.*;
import java.awt.*;

public class LinearAxisCalibrationInstallationNodeView implements SwingInstallationNodeView<LinearAxisCalibrationInstallationNodeContribution> {

	private final SamplePosePanel samplePosePanel;
	private final CalibrationResultPanel CalibrationResultPanel;

	public LinearAxisCalibrationInstallationNodeView() {
		samplePosePanel = new SamplePosePanel(this);
		CalibrationResultPanel = new CalibrationResultPanel(this);
	}

	@Override
	public void buildUI(JPanel jPanel, final LinearAxisCalibrationInstallationNodeContribution installationNode) {
		GridLayout gridLayout = new GridLayout(1, 2);
		jPanel.setLayout(gridLayout);

		jPanel.add(samplePosePanel);
		jPanel.add(CalibrationResultPanel);

	}

	public SamplePosePanel getSamplePosePanel() {
		return samplePosePanel;
	}

	public CalibrationResultPanel getCalibrationResultPanel() {
		return CalibrationResultPanel;
	}
}
