# Rotary Axis Calibration URCap Example
## Description
The rotary-axis-calibration URCap provides a working example for calibrating a rotary axis by sampling
a sequence of TCP poses.
## Build
* The URCap SDK must be installed and available in the build environment
1.
   ```bash
   cd rotary-axis-calibration
   ```
2.
   ```bash
   ./build.sh
   ```
Note: By default the build script will attempt to build the URCap then deploy to a local simulator (if available).
## Usage

1. Go into the Installation tab in Polyscope and click on the Rotary Axis Calibration URCap.
2. To calibrate an axis follow the Calibration Steps laid out in the URCap:
   ![installation node](./docs/images/rotary-axis-calibration-installation-node.png)

   See below images for reference on how to use the MoveTo URCap to increment the rotary axis:
   ![installation node](./docs/images/first_sample_point.png)
   ![installation node](./docs/images/second_sample_point.png)


3. When at least 4 poses have been sampled the 'Calibrate Axis' button will be enabled.
   When the 'Calibrate Axis' button is clicked the URCap will send a URScript with the MotionPlus 'calibrate_rotary_axis' command
   using the sampled poses as arguments. The URCap will then wait for the robot to finish the calibration process before displaying the calibration results.

4. To use the calibration click the 'Copy pose to clipboard' and copy to the desired program or URCap. This can be
   achieved using e.g. the keyboard shortcut (Ctrl+C) or simply by typing in the pose in the desired location.

To start a new calibration click the 'Clear' button to clear the sampled poses.