package com.ur.urcap.externalaxis.rotaryaxiscalibration.URCommunicator;

public class ScriptCommand {

    private final String primary_prefix = "def ";

    private final String programName;
    private final String postfix = "end\n";

    private StringBuilder commandContent = new StringBuilder("");

    /**
     * Create a new ScriptCommand
     */
    public ScriptCommand() {
        this.programName = "myCustomScript():\n";
    }

    /**
     * Create a new ScriptCommand with a custom name
     * 
     * @param commandName the custom name (must be alphanumeric, start with letter)
     */
    public ScriptCommand(String commandName) {
        this.programName = commandName + "():\n";
    }

    /**
     * Append a URScript line to the ScriptCommand
     * 
     * @param command the URScript line to append
     */
    public void appendLine(String command) {
        commandContent.append("  ");
        commandContent.append(command);
        commandContent.append("\n");
    }

    @Override
    public String toString() {
        StringBuilder command = new StringBuilder("");
        command.append(primary_prefix);
        command.append(this.programName);
        command.append(this.commandContent);
        command.append(this.postfix);
        return command.toString();
    }

}
