package com.ur.urcap.externalaxis.rotaryaxiscalibration.installationNode;

import com.ur.urcap.api.contribution.ViewAPIProvider;
import com.ur.urcap.api.contribution.installation.ContributionConfiguration;
import com.ur.urcap.api.contribution.installation.CreationContext;
import com.ur.urcap.api.contribution.installation.InstallationAPIProvider;
import com.ur.urcap.api.contribution.installation.swing.SwingInstallationNodeService;
import com.ur.urcap.api.domain.SystemAPI;
import com.ur.urcap.api.domain.data.DataModel;

import com.ur.urcap.externalaxis.rotaryaxiscalibration.impl.V5Style;
import com.ur.urcap.externalaxis.rotaryaxiscalibration.impl.Style;
import com.ur.urcap.externalaxis.rotaryaxiscalibration.impl.V3Style;
import com.ur.urcap.externalaxis.rotaryaxiscalibration.installationNode.installationNodeContribution.RotaryAxisCalibrationInstallationNodeContribution;
import com.ur.urcap.externalaxis.rotaryaxiscalibration.installationNode.installationNodeView.RotaryAxisCalibrationInstallationNodeView;

import java.util.Locale;

public class RotaryAxisCalibrationInstallationNodeService implements SwingInstallationNodeService<RotaryAxisCalibrationInstallationNodeContribution, RotaryAxisCalibrationInstallationNodeView> {

	@Override
	public void configureContribution(ContributionConfiguration configuration) {
	}

	@Override
	public String getTitle(Locale locale) {
		return "Rotary Axis Calibration";
	}

	@Override
	public RotaryAxisCalibrationInstallationNodeView createView(ViewAPIProvider apiProvider) {
		SystemAPI systemAPI = apiProvider.getSystemAPI();
		Style style = systemAPI.getSoftwareVersion().getMajorVersion() >= 5 ? new V5Style() : new V3Style();
		return new RotaryAxisCalibrationInstallationNodeView(style);
	}

	@Override
	public RotaryAxisCalibrationInstallationNodeContribution createInstallationNode(
			InstallationAPIProvider apiProvider,
			RotaryAxisCalibrationInstallationNodeView view,
			DataModel model,
			CreationContext context) {
		return new RotaryAxisCalibrationInstallationNodeContribution(apiProvider, view);
	}
}
